=== debian/changelog ===
glfw3 (3.3-1) unstable; urgency=medium

  * New upstream version.

  * d/control:
    - Bump debhelper compat to 12.
    - Add Suggests: libglfw3-doc to libglfw3-dev. (Closes: #890777)
    - Use secure Homepage URL.
    - Remove "Testsuite: autopkgtest" field.
    - Use new salsa git URLs.
    - Enable Rules-Requires-Root.
    - Bump standards to 4.3.0.
    - Remove "Priority: extra" from libglfw3-wayland.
    - Update build dependencies.
    - Add new runtime dependencies.
      libglfw3 and libglfw3-wayland now only depend on the libraries
      required by the default configuaration of glfw.
  * d/copyright:
    - Use secure URLs.
    - Various updates for 3.3.
  * d/not-installed: Add file to silence warnings.
  * d/patches: Refresh patches.
  * d/rules:
    - Remove --parallel flag from dh invocation.
    - Remove LIB_SUFFIX and GLFW_BUILD_ options.
    - Put documentation under libglfw-dev.
  * d/*.symbols: Add new symbols exported by 3.3.

 -- James Cowgill <jcowgill@debian.org>  Mon, 15 Jul 2019 11:52:48 +0100
