=== debian/changelog ===
glfw3 (3.3.2-1) unstable; urgency=medium

  * New upstream version.

  * d/copyright: Updates for 3.3.2.
  * d/control: Bump standards version to 4.5.0.
  * d/patches: Refresh patches.
  * d/tests: Replace ADTTMP with AUTOPKGTEST_TMP.

 -- James Cowgill <jcowgill@debian.org>  Tue, 28 Jan 2020 22:24:38 +0000
