=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
  pkg-config [linux-any],
  wayland-protocols (>= 1.15) [linux-any],
 Build-Depends-Indep: doxygen
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Homepage: https://www.glfw.org/
 Vcs-Git: https://salsa.debian.org/games-team/glfw3.git
 Vcs-Browser: https://salsa.debian.org/games-team/glfw3
